/**
  System Traps Generated Driver File 

  @Company:
    Microchip Technology Inc.

  @File Name:
    traps.h

  @Summary:
    This is the generated driver implementation file for handling traps
    using MPLAB(c) Code Configurator

  @Description:
    This source file provides implementations for MPLAB(c) Code Configurator traps.
    Generation Information : 
        Product Revision  :  MPLAB(c) Code Configurator - 3.16
        Device            :  PIC24FJ128GA010
        Version           :  1.00
    The generated drivers are tested against the following:
        Compiler          :  XC16 1.26
        MPLAB             :  MPLAB X 3.20
*/
/*
    (c) 2016 Microchip Technology Inc. and its subsidiaries. You may use this
    software and any derivatives exclusively with Microchip products.

    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY IMPLIED
    WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS FOR A
    PARTICULAR PURPOSE, OR ITS INTERACTION WITH MICROCHIP PRODUCTS, COMBINATION
    WITH ANY OTHER PRODUCTS, OR USE IN ANY APPLICATION.

    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE,
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP HAS
    BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO THE
    FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL CLAIMS IN
    ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT OF FEES, IF ANY,
    THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS SOFTWARE.

    MICROCHIP PROVIDES THIS SOFTWARE CONDITIONALLY UPON YOUR ACCEPTANCE OF THESE
    TERMS.
*/

/**
    Section: Includes
*/
#include <xc.h>
#include <stdbool.h>
#include "traps.h"
#include "../UART.h"
#include "../LCD.h"

#define ERROR_HANDLER __attribute__((interrupt,no_auto_psv))
#define ERROR_HANDLER_NORETURN ERROR_HANDLER __attribute__((noreturn))
#define FAILSAFE_STACK_GUARDSIZE 8


/**
 * a private place to store the error code if we run into a severe error
 */
static uint16_t TRAPS_error_code = -1;

/**
 * Halts 
 * 
 * @param code error code
 */
void __attribute__((naked, noreturn, weak)) TRAPS_halt_on_error(uint16_t code)
{
    TRAPS_error_code = code;
//    UART_enviarString("TRAPS_error_code -1\n");
    switch (TRAPS_error_code) {
        case -1:
//            UART_enviarString("TRAPS_error_code -1");
            break;
        case 0:
//            UART_enviarString("TRAPS_error_code 0 OSCILATOR ERROR");
            if(LCD_IS_ON){
                LCD_TrapSafe_ClearScreen();
                LCD_Send_String("Trap: fallo en\r el ocilador");
            }
            break;
        case 1:
//            UART_enviarString("TRAPS_error_code 1 STACK ERROR");
            if(LCD_IS_ON){
                LCD_TrapSafe_ClearScreen();
                LCD_Send_String("Trap: error en\r la pila");
            }
            break;
        case 2:
//            UART_enviarString("TRAPS_error_code 2 ADDRESS ERROR");
            if(LCD_IS_ON){
                LCD_TrapSafe_ClearScreen();
                LCD_Send_String("Trap: error de\r direccion");
            }
            break;
        case 3:
//            UART_enviarString("TRAPS_error_code 3 MATH ERROR");
            if(LCD_IS_ON){
                LCD_TrapSafe_ClearScreen();
                LCD_Send_String("Trap: error de\r math");
            }
            break;
    }  
#ifdef __DEBUG  
    __builtin_software_breakpoint();
    /* If we are in debug mode, cause a software breakpoint in the debugger */
#else
    while(1);
    
#endif
    Nop();
    Nop();
    Nop();
//    return;
}

/**
 * Sets the stack pointer to a backup area of memory, in case we run into
 * a stack error (in which case we can't really trust the stack pointer)
 */
inline static void use_failsafe_stack(void)
{
    static uint8_t failsafe_stack[32];
    asm volatile (
        "   mov    %[pstack], W15\n"
        :
        : [pstack]"r"(failsafe_stack)
    );
/* Controls where the stack pointer limit is, relative to the end of the
 * failsafe stack
 */    
    SPLIM = (uint16_t)(((uint8_t *)failsafe_stack) + sizeof(failsafe_stack) 
            - FAILSAFE_STACK_GUARDSIZE);
}

/** Oscillator Fail Trap Vector */
void ERROR_HANDLER_NORETURN _OscillatorFail(void)
{     
    INTCON1bits.OSCFAIL = 0;        //Clear the trap flag
    TRAPS_halt_on_error(TRAPS_OSC_FAIL);
}

/** Stack Error Trap Vector */
void ERROR_HANDLER_NORETURN _StackError(void)
{ 
    /* We use a failsafe stack: the presence of a stack-pointer error
     * means that we cannot trust the stack to operate correctly unless
     * we set the stack pointer to a safe place.
     */
    use_failsafe_stack(); 

    INTCON1bits.STKERR = 0;        //Clear the trap flag
    TRAPS_halt_on_error(TRAPS_STACK_ERR);
}

/** Address Error Trap Vector */
void ERROR_HANDLER _AddressError(void)
{ 
    INTCON1bits.ADDRERR = 0;        //Clear the trap flag
    //    TRAPS_halt_on_error(TRAPS_ADDRESS_ERR);
    if(LCD_IS_ON){
        LCD_TrapSafe_ClearScreen();
        LCD_Send_String("Trap: error de\r direccion");
    }
#ifdef __DEBUG  
    __builtin_software_breakpoint();
    /* If we are in debug mode, cause a software breakpoint in the debugger */
#else
    while(1);
#endif
    Nop();
//    main();
}

/** Math Error Trap Vector */
void ERROR_HANDLER_NORETURN _MathError(void)
{ 
    INTCON1bits.MATHERR = 0;        //Clear the trap flag
    TRAPS_halt_on_error(TRAPS_MATH_ERR);
}



//void (*getErrLoc(void))(void);  // Get Address Error Loc
//void (*errLoc)(void);           // Function Pointer   
//
//
//void __attribute__((__interrupt__)) _OscillatorFail(void);
//void __attribute__((__interrupt__)) _AddressError(void);
//void __attribute__((__interrupt__)) _StackError(void);
//void __attribute__((__interrupt__)) _MathError(void);
//
//void __attribute__((__interrupt__)) _AltOscillatorFail(void);
//void __attribute__((__interrupt__)) _AltAddressError(void);
//void __attribute__((__interrupt__)) _AltStackError(void);
//void __attribute__((__interrupt__)) _AltMathError(void);
//
///*
//Primary Exception Vector handlers:
//These routines are used if INTCON2bits.ALTIVT = 0.
//All trap service routines in this file simply ensure that device
//continuously executes code within the trap service routine. Users
//may modify the basic framework provided here to suit to the needs
//of their application.
//*/
//void __attribute__((interrupt, no_auto_psv)) _OscillatorFail(void)
//{
//        INTCON1bits.OSCFAIL = 0;        //Clear the trap flag
//        while (1);
//}
//
//void __attribute__((interrupt, no_auto_psv)) _AddressError(void)
//{
//		errLoc = getErrLoc();	// get the location of error function
//		
//        INTCON1bits.ADDRERR = 0;	//Clear the trap flag
//        asm (_getErrLoc:
//                mov    w14,w2
//                sub    w2,#24,w2
//                mov    [w2++],w0
//                mov    [w2++],w1 
//                mov    #0x7f,w3     ; Mask off non-address bits
//                and    w1,w3,w1
//            ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
//            ;; The instructions above will return to the next 
//            ;; instruction of the error location. 
//            ;; If you want to return to the error location, 
//            ;; you should decomment the following instructions.
//            ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;  
//            ;	mov    #2,w2        ; Decrement the address by 2
//            ;	sub    w0,w2,w0
//            ;	clr    w2
//            ;	subb   w1,w2,w1
//                return)
//    //	errLoc();		// return to error function directly
//        // it is preferred to return by RETFIE instruction. 
//}
//void __attribute__((interrupt, no_auto_psv)) _StackError(void)
//{
//        INTCON1bits.STKERR = 0; //Clear the trap flag
//		while (1);
//}
//
//void __attribute__((interrupt, no_auto_psv)) _MathError(void)
//{
//        INTCON1bits.MATHERR = 0;        //Clear the trap flag
//        while (1);
//}
//
//
//
//
///*
//Alternate Exception Vector handlers:
//These routines are used if INTCON2bits.ALTIVT = 1.
//All trap service routines in this file simply ensure that device
//continuously executes code within the trap service routine. Users
//may modify the basic framework provided here to suit to the needs
//of their application.
//*/
//
//void __attribute__((interrupt, no_auto_psv)) _AltOscillatorFail(void)
//{
//        INTCON1bits.OSCFAIL = 0;
//        while (1);
//}
//
//void __attribute__((interrupt, no_auto_psv)) _AltAddressError(void)
//{
//        INTCON1bits.ADDRERR = 0;
//        while (1);
//}
//
//void __attribute__((interrupt, no_auto_psv)) _AltStackError(void)
//{
//        INTCON1bits.STKERR = 0;
//        while (1);
//}
//
//void __attribute__((interrupt, no_auto_psv)) _AltMathError(void)
//{
//        INTCON1bits.MATHERR = 0;
//        while (1);
//}
